/*
    BEURTEILUNG: 55 Punkte
*/
public class Exercise4 {

    /*
    Implementieren Sie die folgenden Methoden möglichst kurz entsprechend der Beschreibungen in den Kommentaren.
    Lesen Sie zuerst alle Beschreibungen durch und beginnen Sie erst danach mit den Implementierungen.
    Allgemeiner Hinweis: Ihre Implementierungen müssen nur positive Parameterwerte berücksichtigen!

    Punkte:
      Für diese Aufgabe sind 55 Punkte erreichbar:
        20 Punkte für threshold,
        20 Punkte für superThreshold,
        15 Punkte für main.
      Es werden auch richtige Teilschritte bewertet.
    */

    private static boolean threshold(int start, int end, int n) {
        // Zählt alle durch 3 teilbaren Zahlen im Intervall start und end und gibt genau dann true zurück, wenn die Anzahl kleiner als n ist;
        // start ist die untere Grenze (exklusive) und end die obere Grenze (inklusive) des Intervalls.
        // Bei start > end ist das Ergebnis false.
        // Beispiele:
        //   threshold(10,30,4) gibt false zurück,
        //   threshold(16,5,2) gibt false zurück.

        int divisible = 0;

        /* 12, 15, 18, 21, 24, 27, 30 */
        for (int i = start + 1; i <= end; i ++) {
            if (i % 3 == 0) {
                divisible ++;
            }
        }

        if (start <= end && divisible < n) {
            return true;
        }

        return false;
    }

    private static boolean superThreshold(int first, int second, int n) {
        // Zählt alle durch 3 teilbaren Zahlen im durch die Parameter first und second festgelegten Intervall
        // first und end und gibt genau dann true zurück, wenn die Anzahl kleiner als n ist;
        // Der kleinere Wert (von first und second) gibt die untere Grenze (exklusive) des Intervalls an,
        // der größere Wert gibt die obere Grenze (inklusive) des Intervalls an.
        // Beispiele:
        //   superThreshold(10,30,4) gibt false zurück,
        //   superThreshold(16,5,2) gibt false zurück.

        return threshold(first < second ? first : second, first > second ? first : second, n);
    }

    public static void main(String[] args) {
        // Führen Sie folgende Aufrufe aus und geben Sie nur die Ergebnisse jeweils in einer eigenen Zeile aus:
        //   threshold(10,30,4)
        //   threshold(16,5,2)
        //   superThreshold(10,30,4)
        //   superThreshold(16,5,2)
        System.out.println(threshold(10, 30, 4)); // false
        System.out.println(threshold(16, 5, 2)); // false
        System.out.println(superThreshold(10, 30, 4)); // false
        System.out.println(superThreshold(16, 5, 2)); // false
    }
}